--
-- ManureSpreaderPlaneMover
-- Specialization for plane uv scroller movement on manure spreaders
--
-- @author  Stefan Maurus    
-- @date  2015-09-16

-- Copyright © Stefan Maurus, www.stefanmaurus.de

ManureSpreaderPlaneMover = {};

function ManureSpreaderPlaneMover.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Fillable, specializations) and SpecializationUtil.hasSpecialization(TurnOnVehicle, specializations);
end

function ManureSpreaderPlaneMover:load(savegame)
end

function ManureSpreaderPlaneMover:delete()
end

function ManureSpreaderPlaneMover:mouseEvent(posX, posY, isDown, isUp, button)
end

function ManureSpreaderPlaneMover:keyEvent(unicode, sym, modifier, isDown)
end

function ManureSpreaderPlaneMover:update(dt)
    if self.isClient then
        if self.isTurnedOn then
            for i,fillVolume in pairs(self.fillVolumes) do
                if fillVolume.scrollSpeedDischarge[1] ~= 0 or fillVolume.scrollSpeedDischarge[2] ~= 0 or fillVolume.scrollSpeedDischarge[3] ~= 0 then
                    fillVolume.uvPosition[1] = fillVolume.uvPosition[1] + fillVolume.scrollSpeedDischarge[1]*dt;
                    fillVolume.uvPosition[2] = fillVolume.uvPosition[2] + fillVolume.scrollSpeedDischarge[2]*dt;
                    fillVolume.uvPosition[3] = fillVolume.uvPosition[3] + fillVolume.scrollSpeedDischarge[3]*dt;
                    setShaderParameter(fillVolume.volume, "uvOffset", fillVolume.uvPosition[1], fillVolume.uvPosition[2], fillVolume.uvPosition[3], 0, false);
                end;
            end;
        end;
    end;
end

function ManureSpreaderPlaneMover:updateTick(dt)
end

function ManureSpreaderPlaneMover:draw()
end